'--------------------------------------------------------------------------
'  DeMo-Neowin.vbs Script
'
' This script is designed to grab news from Neowin.net
' Using Neowin's RDF files.
'
' You may retrieve Main, Software and Gamers news and the
' last 10 forum posts.
'
' This is version 1.0
' Contact me @ http://www.samurize.com/modules/ipboard/index.php?showuser=230
'
'--------------------------------------------------------------------------


'----------------- CONFIGURATION -----------------
Const NEOWIN_ADDR = "http://www.neowin.net/" 	'Neowin website address
Const TOTALNEWS = "10"                       	'How many news you want to return (Max: 10)
'----------------- CONFIGURATION -----------------



'----------------- DO NOT CHANGE ANYTHING BELOW THIS LINE!!! -----------------

Function GetMainNews()
    GetMainNews = getNews("main")
End Function

Function GetGamerNews()
    GetGamerNews = getNews("gamer")
End Function

Function GetSoftwareNews()
    GetSoftwareNews = getNews("software")
End Function

Function GetForumPosts()
    GetForumPosts = getNews("forum")
End Function



Function getNews(Section)


    Dim htmlResult
    ReDim strTitle(TOTALNEWS)

    If Section = "main" Then htmlResult = ReturnHTML(NEOWIN_ADDR & "backend.php?page=main")
    If Section = "gamer" Then htmlResult = ReturnHTML(NEOWIN_ADDR & "backend.php?page=gamers")
    If Section = "software" Then htmlResult = ReturnHTML(NEOWIN_ADDR & "backend.php?page=software")
    If Section = "forum" Then htmlResult = ReturnHTML(NEOWIN_ADDR & "backend.php?page=forum")
    
    WorkingResult = HTMLSpecialCharacters_(htmlResult)

    Set RE = New RegExp
    RE.Global = True

    'Get News titles
    RE.Pattern = "<title>(.*?)</title>"
    
    Set titletemp = RE.Execute(WorkingResult)

    For i = 1 To TOTALNEWS
      Set oMatch = titletemp(i + 1)
      strTitle(i) = oMatch.SubMatches(0)
    Next
    
    For b = 1 To TOTALNEWS
      getNews = getNews & strTitle(b) & vbCrLf
    Next

End Function

Function ReturnHTML(sURL)
    Randomize
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function


'Thanks to AdamC for these functions below!!

Function HTMLSpecialCharacters_(varText)
    varText = ChangeHTMLCharacters_(varText, "&nbsp;", " ")
    varText = ChangeHTMLCharacters_(varText, "&quot;", """")
    varText = ChangeHTMLCharacters_(varText, "&amp;", "&")
    varText = ChangeHTMLCharacters_(varText, "&lt;", "<")
    varText = ChangeHTMLCharacters_(varText, "&gt;", ">")
    varText = ChangeHTMLCharacters_(varText, "&copy;", "")
    varText = ChangeHTMLCharacters_(varText, "&trade;", "")
    varText = ChangeHTMLCharacters_(varText, "&#33;", "!")
    varText = ChangeHTMLCharacters_(varText, "&#34;", """")
    varText = ChangeHTMLCharacters_(varText, "&#35;", "#")
    varText = ChangeHTMLCharacters_(varText, "&#36;", "$")
    varText = ChangeHTMLCharacters_(varText, "&#37;", "%")
    varText = ChangeHTMLCharacters_(varText, "&#38;", "&")
    varText = ChangeHTMLCharacters_(varText, "&#39;", "'")
    varText = ChangeHTMLCharacters_(varText, "&#40;", "(")
    varText = ChangeHTMLCharacters_(varText, "&#41;", ")")
    varText = ChangeHTMLCharacters_(varText, "&#42;", "*")
    varText = ChangeHTMLCharacters_(varText, "&#43;", "+")
    varText = ChangeHTMLCharacters_(varText, "&#44;", ",")
    varText = ChangeHTMLCharacters_(varText, "&#45;", "-")
    varText = ChangeHTMLCharacters_(varText, "&#46;", ".")
    varText = ChangeHTMLCharacters_(varText, "&#47;", "/")
    varText = ChangeHTMLCharacters_(varText, "&#58;", ";")
    varText = ChangeHTMLCharacters_(varText, "&#59;", ";")
    varText = ChangeHTMLCharacters_(varText, "&#60;", "<")
    varText = ChangeHTMLCharacters_(varText, "&#61;", "=")
    varText = ChangeHTMLCharacters_(varText, "&#62;", ">")
    varText = ChangeHTMLCharacters_(varText, "&#63;", "?")
    varText = ChangeHTMLCharacters_(varText, "&#64;", "@")
    varText = ChangeHTMLCharacters_(varText, "&#91;", "[")
    varText = ChangeHTMLCharacters_(varText, "&#92;", "\")
    varText = ChangeHTMLCharacters_(varText, "&#93;", "]")
    varText = ChangeHTMLCharacters_(varText, "&#94;", "^")
    varText = ChangeHTMLCharacters_(varText, "&#95;", "_")
    varText = ChangeHTMLCharacters_(varText, "&#96;", "`")
    varText = ChangeHTMLCharacters_(varText, "&#123;", "{")
    varText = ChangeHTMLCharacters_(varText, "&#124;", "|")
    varText = ChangeHTMLCharacters_(varText, "&#125;", "}")
    varText = ChangeHTMLCharacters_(varText, "&#126;", "~")
    varText = ChangeHTMLCharacters_(varText, "&#169;", "")
    varText = ChangeHTMLCharacters_(varText, "&#174;", "")

    HTMLSpecialCharacters_ = varText
End Function


Function ChangeHTMLCharacters_(varText, varString, varReplaceWith)
    While InStr(varText, varString) > 0
        varText = Replace(varText, varString, varReplaceWith)
    Wend
    ChangeHTMLCharacters_ = varText
End Function
